Index: lemon/maps.h
===================================================================
--- lemon/maps.h	(revision 584)
+++ lemon/maps.h	(revision 440)
@@ -2345,39 +2293,37 @@
   /// This function just returns an \c SourceMap class.
   /// \relates SourceMap
-  template <typename GR>
-  inline SourceMap<GR> sourceMap(const GR& graph) {
-    return SourceMap<GR>(graph);
-  }
-
-  /// \brief Map of the target nodes of arcs in a digraph.
-  ///
-  /// TargetMap provides access for the target node of each arc in a digraph,
-  /// which is returned by the \c target() function of the digraph.
-  /// \tparam GR The digraph type.
+  template <typename Digraph>
+  inline SourceMap<Digraph> sourceMap(const Digraph& digraph) {
+    return SourceMap<Digraph>(digraph);
+  }
+
+  /// \brief Returns the target of the given arc.
+  ///
+  /// The TargetMap gives back the target Node of the given arc.
   /// \see SourceMap
-  template <typename GR>
+  template <typename Digraph>
   class TargetMap {
   public:
 
-    ///\e
-    typedef typename GR::Arc Key;
-    ///\e
-    typedef typename GR::Node Value;
+    typedef typename Digraph::Node Value;
+    typedef typename Digraph::Arc Key;
 
     /// \brief Constructor
     ///
-    /// Constructor.
+    /// Constructor
     /// \param digraph The digraph that the map belongs to.
-    explicit TargetMap(const GR& digraph) : _graph(digraph) {}
-
-    /// \brief Returns the target node of the given arc.
-    ///
-    /// Returns the target node of the given arc.
+    explicit TargetMap(const Digraph& digraph) : _digraph(digraph) {}
+
+    /// \brief The subscript operator.
+    ///
+    /// The subscript operator.
+    /// \param e The arc
+    /// \return The target of the arc
     Value operator[](const Key& e) const {
-      return _graph.target(e);
+      return _digraph.target(e);
     }
 
   private:
-    const GR& _graph;
+    const Digraph& _digraph;
   };
 
@@ -2386,32 +2332,31 @@
   /// This function just returns a \c TargetMap class.
   /// \relates TargetMap
-  template <typename GR>
-  inline TargetMap<GR> targetMap(const GR& graph) {
-    return TargetMap<GR>(graph);
-  }
-
-  /// \brief Map of the "forward" directed arc view of edges in a graph.
-  ///
-  /// ForwardMap provides access for the "forward" directed arc view of
-  /// each edge in a graph, which is returned by the \c direct() function
-  /// of the graph with \c true parameter.
-  /// \tparam GR The graph type.
+  template <typename Digraph>
+  inline TargetMap<Digraph> targetMap(const Digraph& digraph) {
+    return TargetMap<Digraph>(digraph);
+  }
+
+  /// \brief Returns the "forward" directed arc view of an edge.
+  ///
+  /// Returns the "forward" directed arc view of an edge.
   /// \see BackwardMap
-  template <typename GR>
+  template <typename Graph>
   class ForwardMap {
   public:
 
-    typedef typename GR::Arc Value;
-    typedef typename GR::Edge Key;
+    typedef typename Graph::Arc Value;
+    typedef typename Graph::Edge Key;
 
     /// \brief Constructor
     ///
-    /// Constructor.
+    /// Constructor
     /// \param graph The graph that the map belongs to.
-    explicit ForwardMap(const GR& graph) : _graph(graph) {}
-
-    /// \brief Returns the "forward" directed arc view of the given edge.
-    ///
-    /// Returns the "forward" directed arc view of the given edge.
+    explicit ForwardMap(const Graph& graph) : _graph(graph) {}
+
+    /// \brief The subscript operator.
+    ///
+    /// The subscript operator.
+    /// \param key An edge
+    /// \return The "forward" directed arc view of edge
     Value operator[](const Key& key) const {
       return _graph.direct(key, true);
@@ -2419,5 +2364,5 @@
 
   private:
-    const GR& _graph;
+    const Graph& _graph;
   };
 
@@ -2426,32 +2371,31 @@
   /// This function just returns an \c ForwardMap class.
   /// \relates ForwardMap
-  template <typename GR>
-  inline ForwardMap<GR> forwardMap(const GR& graph) {
-    return ForwardMap<GR>(graph);
-  }
-
-  /// \brief Map of the "backward" directed arc view of edges in a graph.
-  ///
-  /// BackwardMap provides access for the "backward" directed arc view of
-  /// each edge in a graph, which is returned by the \c direct() function
-  /// of the graph with \c false parameter.
-  /// \tparam GR The graph type.
+  template <typename Graph>
+  inline ForwardMap<Graph> forwardMap(const Graph& graph) {
+    return ForwardMap<Graph>(graph);
+  }
+
+  /// \brief Returns the "backward" directed arc view of an edge.
+  ///
+  /// Returns the "backward" directed arc view of an edge.
   /// \see ForwardMap
-  template <typename GR>
+  template <typename Graph>
   class BackwardMap {
   public:
 
-    typedef typename GR::Arc Value;
-    typedef typename GR::Edge Key;
+    typedef typename Graph::Arc Value;
+    typedef typename Graph::Edge Key;
 
     /// \brief Constructor
     ///
-    /// Constructor.
+    /// Constructor
     /// \param graph The graph that the map belongs to.
-    explicit BackwardMap(const GR& graph) : _graph(graph) {}
-
-    /// \brief Returns the "backward" directed arc view of the given edge.
-    ///
-    /// Returns the "backward" directed arc view of the given edge.
+    explicit BackwardMap(const Graph& graph) : _graph(graph) {}
+
+    /// \brief The subscript operator.
+    ///
+    /// The subscript operator.
+    /// \param key An edge
+    /// \return The "backward" directed arc view of edge
     Value operator[](const Key& key) const {
       return _graph.direct(key, false);
@@ -2459,5 +2403,5 @@
 
   private:
-    const GR& _graph;
+    const Graph& _graph;
   };
 
@@ -2466,21 +2410,61 @@
   /// This function just returns a \c BackwardMap class.
   /// \relates BackwardMap
-  template <typename GR>
-  inline BackwardMap<GR> backwardMap(const GR& graph) {
-    return BackwardMap<GR>(graph);
-  }
-
-  /// \brief Map of the in-degrees of nodes in a digraph.
+  template <typename Graph>
+  inline BackwardMap<Graph> backwardMap(const Graph& graph) {
+    return BackwardMap<Graph>(graph);
+  }
+
+  /// \brief Potential difference map
+  ///
+  /// If there is an potential map on the nodes then we
+  /// can get an arc map as we get the substraction of the
+  /// values of the target and source.
+  template <typename Digraph, typename NodeMap>
+  class PotentialDifferenceMap {
+  public:
+    typedef typename Digraph::Arc Key;
+    typedef typename NodeMap::Value Value;
+
+    /// \brief Constructor
+    ///
+    /// Contructor of the map
+    explicit PotentialDifferenceMap(const Digraph& digraph,
+                                    const NodeMap& potential)
+      : _digraph(digraph), _potential(potential) {}
+
+    /// \brief Const subscription operator
+    ///
+    /// Const subscription operator
+    Value operator[](const Key& arc) const {
+      return _potential[_digraph.target(arc)] -
+        _potential[_digraph.source(arc)];
+    }
+
+  private:
+    const Digraph& _digraph;
+    const NodeMap& _potential;
+  };
+
+  /// \brief Returns a PotentialDifferenceMap.
+  ///
+  /// This function just returns a PotentialDifferenceMap.
+  /// \relates PotentialDifferenceMap
+  template <typename Digraph, typename NodeMap>
+  PotentialDifferenceMap<Digraph, NodeMap>
+  potentialDifferenceMap(const Digraph& digraph, const NodeMap& potential) {
+    return PotentialDifferenceMap<Digraph, NodeMap>(digraph, potential);
+  }
+
+  /// \brief Map of the node in-degrees.
   ///
   /// This map returns the in-degree of a node. Once it is constructed,
-  /// the degrees are stored in a standard \c NodeMap, so each query is done
+  /// the degrees are stored in a standard NodeMap, so each query is done
   /// in constant time. On the other hand, the values are updated automatically
   /// whenever the digraph changes.
   ///
-  /// \warning Besides \c addNode() and \c addArc(), a digraph structure 
-  /// may provide alternative ways to modify the digraph.
-  /// The correct behavior of InDegMap is not guarantied if these additional
-  /// features are used. For example the functions
-  /// \ref ListDigraph::changeSource() "changeSource()",
+  /// \warning Besides addNode() and addArc(), a digraph structure may provide
+  /// alternative ways to modify the digraph. The correct behavior of InDegMap
+  /// is not guarantied if these additional features are used. For example
+  /// the functions \ref ListDigraph::changeSource() "changeSource()",
   /// \ref ListDigraph::changeTarget() "changeTarget()" and
   /// \ref ListDigraph::reverseArc() "reverseArc()"
@@ -2488,17 +2472,15 @@
   ///
   /// \sa OutDegMap
-  template <typename GR>
+
+  template <typename _Digraph>
   class InDegMap
-    : protected ItemSetTraits<GR, typename GR::Arc>
+    : protected ItemSetTraits<_Digraph, typename _Digraph::Arc>
       ::ItemNotifier::ObserverBase {
 
   public:
-    
-    /// The digraph type
-    typedef GR Digraph;
-    /// The key type
+
+    typedef _Digraph Digraph;
+    typedef int Value;
     typedef typename Digraph::Node Key;
-    /// The value type
-    typedef int Value;
 
     typedef typename ItemSetTraits<Digraph, typename Digraph::Arc>
@@ -2542,7 +2524,7 @@
     /// \brief Constructor.
     ///
-    /// Constructor for creating an in-degree map.
-    explicit InDegMap(const Digraph& graph)
-      : _digraph(graph), _deg(graph) {
+    /// Constructor for creating in-degree map.
+    explicit InDegMap(const Digraph& digraph)
+      : _digraph(digraph), _deg(digraph) {
       Parent::attach(_digraph.notifier(typename Digraph::Arc()));
 
@@ -2552,6 +2534,4 @@
     }
 
-    /// \brief Gives back the in-degree of a Node.
-    ///
     /// Gives back the in-degree of a Node.
     int operator[](const Key& key) const {
@@ -2600,16 +2580,15 @@
   };
 
-  /// \brief Map of the out-degrees of nodes in a digraph.
+  /// \brief Map of the node out-degrees.
   ///
   /// This map returns the out-degree of a node. Once it is constructed,
-  /// the degrees are stored in a standard \c NodeMap, so each query is done
+  /// the degrees are stored in a standard NodeMap, so each query is done
   /// in constant time. On the other hand, the values are updated automatically
   /// whenever the digraph changes.
   ///
-  /// \warning Besides \c addNode() and \c addArc(), a digraph structure 
-  /// may provide alternative ways to modify the digraph.
-  /// The correct behavior of OutDegMap is not guarantied if these additional
-  /// features are used. For example the functions
-  /// \ref ListDigraph::changeSource() "changeSource()",
+  /// \warning Besides addNode() and addArc(), a digraph structure may provide
+  /// alternative ways to modify the digraph. The correct behavior of OutDegMap
+  /// is not guarantied if these additional features are used. For example
+  /// the functions \ref ListDigraph::changeSource() "changeSource()",
   /// \ref ListDigraph::changeTarget() "changeTarget()" and
   /// \ref ListDigraph::reverseArc() "reverseArc()"
@@ -2617,17 +2596,15 @@
   ///
   /// \sa InDegMap
-  template <typename GR>
+
+  template <typename _Digraph>
   class OutDegMap
-    : protected ItemSetTraits<GR, typename GR::Arc>
+    : protected ItemSetTraits<_Digraph, typename _Digraph::Arc>
       ::ItemNotifier::ObserverBase {
 
   public:
 
-    /// The digraph type
-    typedef GR Digraph;
-    /// The key type
+    typedef _Digraph Digraph;
+    typedef int Value;
     typedef typename Digraph::Node Key;
-    /// The value type
-    typedef int Value;
 
     typedef typename ItemSetTraits<Digraph, typename Digraph::Arc>
@@ -2669,7 +2646,7 @@
     /// \brief Constructor.
     ///
-    /// Constructor for creating an out-degree map.
-    explicit OutDegMap(const Digraph& graph)
-      : _digraph(graph), _deg(graph) {
+    /// Constructor for creating out-degree map.
+    explicit OutDegMap(const Digraph& digraph)
+      : _digraph(digraph), _deg(digraph) {
       Parent::attach(_digraph.notifier(typename Digraph::Arc()));
 
@@ -2679,6 +2656,4 @@
     }
 
-    /// \brief Gives back the out-degree of a Node.
-    ///
     /// Gives back the out-degree of a Node.
     int operator[](const Key& key) const {
@@ -2727,54 +2702,4 @@
   };
 
-  /// \brief Potential difference map
-  ///
-  /// PotentialDifferenceMap returns the difference between the potentials of
-  /// the source and target nodes of each arc in a digraph, i.e. it returns
-  /// \code
-  ///   potential[gr.target(arc)] - potential[gr.source(arc)].
-  /// \endcode
-  /// \tparam GR The digraph type.
-  /// \tparam POT A node map storing the potentials.
-  template <typename GR, typename POT>
-  class PotentialDifferenceMap {
-  public:
-    /// Key type
-    typedef typename GR::Arc Key;
-    /// Value type
-    typedef typename POT::Value Value;
-
-    /// \brief Constructor
-    ///
-    /// Contructor of the map.
-    explicit PotentialDifferenceMap(const GR& gr,
-                                    const POT& potential)
-      : _digraph(gr), _potential(potential) {}
-
-    /// \brief Returns the potential difference for the given arc.
-    ///
-    /// Returns the potential difference for the given arc, i.e.
-    /// \code
-    ///   potential[gr.target(arc)] - potential[gr.source(arc)].
-    /// \endcode
-    Value operator[](const Key& arc) const {
-      return _potential[_digraph.target(arc)] -
-        _potential[_digraph.source(arc)];
-    }
-
-  private:
-    const GR& _digraph;
-    const POT& _potential;
-  };
-
-  /// \brief Returns a PotentialDifferenceMap.
-  ///
-  /// This function just returns a PotentialDifferenceMap.
-  /// \relates PotentialDifferenceMap
-  template <typename GR, typename POT>
-  PotentialDifferenceMap<GR, POT>
-  potentialDifferenceMap(const GR& gr, const POT& potential) {
-    return PotentialDifferenceMap<GR, POT>(gr, potential);
-  }
-
   /// @}
 }
Index: lemon/min_cost_arborescence.h
===================================================================
--- lemon/min_cost_arborescence.h	(revision 584)
+++ lemon/min_cost_arborescence.h	(revision 490)
@@ -36,11 +36,11 @@
   ///
   /// Default traits class for MinCostArborescence class.
-  /// \param GR Digraph type.
-  /// \param CM Type of cost map.
-  template <class GR, class CM>
+  /// \param _Digraph Digraph type.
+  /// \param _CostMap Type of cost map.
+  template <class _Digraph, class _CostMap>
   struct MinCostArborescenceDefaultTraits{
 
     /// \brief The digraph type the algorithm runs on.
-    typedef GR Digraph;
+    typedef _Digraph Digraph;
 
     /// \brief The type of the map that stores the arc costs.
@@ -48,5 +48,5 @@
     /// The type of the map that stores the arc costs.
     /// It must meet the \ref concepts::ReadMap "ReadMap" concept.
-    typedef CM CostMap;
+    typedef _CostMap CostMap;
 
     /// \brief The value type of the costs.
@@ -64,23 +64,23 @@
     typedef typename Digraph::template ArcMap<bool> ArborescenceMap;
 
-    /// \brief Instantiates a \c ArborescenceMap.
-    ///
-    /// This function instantiates a \c ArborescenceMap.
+    /// \brief Instantiates a ArborescenceMap.
+    ///
+    /// This function instantiates a \ref ArborescenceMap.
     /// \param digraph is the graph, to which we would like to
-    /// calculate the \c ArborescenceMap.
+    /// calculate the ArborescenceMap.
     static ArborescenceMap *createArborescenceMap(const Digraph &digraph){
       return new ArborescenceMap(digraph);
     }
 
-    /// \brief The type of the \c PredMap
-    ///
-    /// The type of the \c PredMap. It is a node map with an arc value type.
+    /// \brief The type of the PredMap
+    ///
+    /// The type of the PredMap. It is a node map with an arc value type.
     typedef typename Digraph::template NodeMap<typename Digraph::Arc> PredMap;
 
-    /// \brief Instantiates a \c PredMap.
-    ///
-    /// This function instantiates a \c PredMap.
-    /// \param digraph The digraph to which we would like to define the
-    /// \c PredMap.
+    /// \brief Instantiates a PredMap.
+    ///
+    /// This function instantiates a \ref PredMap.
+    /// \param _digraph is the digraph, to which we would like to define the
+    /// PredMap.
     static PredMap *createPredMap(const Digraph &digraph){
       return new PredMap(digraph);
@@ -91,37 +91,39 @@
   /// \ingroup spantree
   ///
-  /// \brief Minimum Cost Arborescence algorithm class.
+  /// \brief %MinCostArborescence algorithm class.
   ///
   /// This class provides an efficient implementation of
-  /// Minimum Cost Arborescence algorithm. The arborescence is a tree
+  /// %MinCostArborescence algorithm. The arborescence is a tree
   /// which is directed from a given source node of the digraph. One or
   /// more sources should be given for the algorithm and it will calculate
   /// the minimum cost subgraph which are union of arborescences with the
   /// given sources and spans all the nodes which are reachable from the
-  /// sources. The time complexity of the algorithm is O(n<sup>2</sup>+e).
+  /// sources. The time complexity of the algorithm is \f$ O(n^2+e) \f$.
   ///
   /// The algorithm provides also an optimal dual solution, therefore
   /// the optimality of the solution can be checked.
   ///
-  /// \param GR The digraph type the algorithm runs on. The default value
+  /// \param _Digraph The digraph type the algorithm runs on. The default value
   /// is \ref ListDigraph.
-  /// \param CM This read-only ArcMap determines the costs of the
+  /// \param _CostMap This read-only ArcMap determines the costs of the
   /// arcs. It is read once for each arc, so the map may involve in
   /// relatively time consuming process to compute the arc cost if
   /// it is necessary. The default map type is \ref
   /// concepts::Digraph::ArcMap "Digraph::ArcMap<int>".
-  /// \param TR Traits class to set various data types used
+  /// \param _Traits Traits class to set various data types used
   /// by the algorithm. The default traits class is
   /// \ref MinCostArborescenceDefaultTraits
-  /// "MinCostArborescenceDefaultTraits<GR, CM>".  See \ref
+  /// "MinCostArborescenceDefaultTraits<_Digraph, _CostMap>".  See \ref
   /// MinCostArborescenceDefaultTraits for the documentation of a
   /// MinCostArborescence traits class.
+  ///
+  /// \author Balazs Dezso
 #ifndef DOXYGEN
-  template <typename GR = ListDigraph,
-            typename CM = typename GR::template ArcMap<int>,
-            typename TR =
-              MinCostArborescenceDefaultTraits<GR, CM> >
+  template <typename _Digraph = ListDigraph,
+            typename _CostMap = typename _Digraph::template ArcMap<int>,
+            typename _Traits =
+            MinCostArborescenceDefaultTraits<_Digraph, _CostMap> >
 #else
-  template <typename GR, typename CM, typedef TR>
+  template <typename _Digraph, typename _CostMap, typedef _Traits>
 #endif
   class MinCostArborescence {
@@ -129,5 +131,5 @@
 
     /// The traits.
-    typedef TR Traits;
+    typedef _Traits Traits;
     /// The type of the underlying digraph.
     typedef typename Traits::Digraph Digraph;
@@ -294,5 +296,5 @@
         }
       }
-      (*_arc_order)[minimum.arc] = _dual_variables.size();
+      _arc_order->set(minimum.arc, _dual_variables.size());
       DualVariable var(_dual_node_list.size() - 1,
                        _dual_node_list.size(), minimum.value);
@@ -336,5 +338,5 @@
         }
       }
-      (*_arc_order)[minimum.arc] = _dual_variables.size();
+      _arc_order->set(minimum.arc, _dual_variables.size());
       DualVariable var(node_bottom, _dual_node_list.size(), minimum.value);
       _dual_variables.push_back(var);
@@ -365,5 +367,5 @@
         Node source = _heap->top();
         _heap->pop();
-        (*_node_order)[source] = -1;
+        _node_order->set(source, -1);
         for (OutArcIt it(*_digraph, source); it != INVALID; ++it) {
           if ((*_arc_order)[it] < 0) continue;
@@ -391,5 +393,5 @@
   public:
 
-    /// \name Named Template Parameters
+    /// \name Named template parameters
 
     /// @{
@@ -439,6 +441,6 @@
     /// \brief Constructor.
     ///
-    /// \param digraph The digraph the algorithm will run on.
-    /// \param cost The cost map used by the algorithm.
+    /// \param _digraph The digraph the algorithm will run on.
+    /// \param _cost The cost map used by the algorithm.
     MinCostArborescence(const Digraph& digraph, const CostMap& cost)
       : _digraph(&digraph), _cost(&cost), _pred(0), local_pred(false),
@@ -455,5 +457,5 @@
     ///
     /// Sets the arborescence map.
-    /// \return <tt>(*this)</tt>
+    /// \return \c (*this)
     MinCostArborescence& arborescenceMap(ArborescenceMap& m) {
       if (local_arborescence) {
@@ -468,5 +470,5 @@
     ///
     /// Sets the arborescence map.
-    /// \return <tt>(*this)</tt>
+    /// \return \c (*this)
     MinCostArborescence& predMap(PredMap& m) {
       if (local_pred) {
@@ -631,5 +633,5 @@
     /// @}
 
-    /// \name Execution Control
+    /// \name Execution control
     /// The simplest way to execute the algorithm is to use
     /// one of the member functions called \c run(...). \n
@@ -651,11 +653,11 @@
       for (NodeIt it(*_digraph); it != INVALID; ++it) {
         (*_cost_arcs)[it].arc = INVALID;
-        (*_node_order)[it] = -3;
-        (*_heap_cross_ref)[it] = Heap::PRE_HEAP;
+        _node_order->set(it, -3);
+        _heap_cross_ref->set(it, Heap::PRE_HEAP);
         _pred->set(it, INVALID);
       }
       for (ArcIt it(*_digraph); it != INVALID; ++it) {
         _arborescence->set(it, false);
-        (*_arc_order)[it] = -1;
+        _arc_order->set(it, -1);
       }
       _dual_node_list.clear();
